SystemOrganization addCategory: #'Pier-Seaside-Core'!
SystemOrganization addCategory: #'Pier-Seaside-Model'!
SystemOrganization addCategory: #'Pier-Seaside-Renderer'!
SystemOrganization addCategory: #'Pier-Seaside-View'!
SystemOrganization addCategory: #'Pier-Seaside-Widgets'!
SystemOrganization addCategory: #'Pier-Seaside-Magritte'!

PREditCommand subclass: #PREditComponentCommand
	instanceVariableNames: 'componentClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Model'!

!PREditComponentCommand class methodsFor: 'accessing-configuration' stamp: 'lr 11/17/2005 15:45'!
defaultStructureClass
	^ PRComponent! !

!PREditComponentCommand class methodsFor: 'accessing-description' stamp: 'lr 11/17/2005 15:45'!
descriptionComponentClass
	^ (MASingleOptionDescription selector: #componentClass label: 'Component Class' priority: 200)
		options: (MADynamicObject on: [
			Array streamContents: [ :stream |
				PRWidget allSubclassesDo: [ :each |
					each isAbstract
						ifFalse: [ stream nextPut: each ] ].
				WAComponent allSubclassesDo: [ :each |
					each canBeRoot
						ifTrue: [ stream nextPut: each ] ] ] ]);
		reference: MAClassDescription new;
		beRequired;
		beSorted;
		yourself.! !

!PREditComponentCommand class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PREditComponentCommand methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:19'!
accept: aVisitor
	aVisitor visitEditComponentCommand: self.! !

!PREditComponentCommand methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
componentClass
	^ componentClass! !

!PREditComponentCommand methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
componentClass: aClass
	componentClass := aClass! !

!PREditComponentCommand methodsFor: 'events' stamp: 'lr 10/21/2005 10:55'!
doAnswer
	super doAnswer.
	self context removeComponentAt: self context structure.! !

!PREditComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:01'!
doExecute
	super doExecute.
	self structure componentClass: self componentClass.! !

!PREditComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:01'!
doInitialize
	super doInitialize.
	self componentClass: self context structure componentClass.! !

!PRViewCommand methodsFor: '*pier-seaside-converting' stamp: 'lr 10/21/2005 13:26'!
asComponent
	^ self viewComponent.! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 15:24'!
viewComponent
	^ self propertyAt: #viewComponent ifAbsentPut: [ self viewComponentClass on: self context ].! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 15:24'!
viewComponentClass
	^ self propertyAt: #viewComponentClass ifAbsentPut: [ self context structure viewComponentClass ].! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 15:23'!
viewComponentClass: aClass
	self propertyAt: #viewComponentClass put: aClass.! !

!PRViewCommand methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 13:25'!
viewComponent: aViewComponent
	self propertyAt: #viewComponent put: aViewComponent.! !

!WAPresenter methodsFor: '*pier-seaside-events' stamp: 'lr 10/25/2005 23:11'!
onChangeContext: aContext
	"Inform components about a new context that will be used from now on."! !

!PRCommand methodsFor: '*pier-seaside' stamp: 'lr 4/17/2005 11:57'!
asComponent
	^ super asComponent
		addValidatedForm;
		yourself.! !

PRCommand subclass: #PRSettingsComponentCommand
	instanceVariableNames: 'settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Model'!

!PRSettingsComponentCommand class methodsFor: 'accessing-configuration' stamp: 'lr 11/17/2005 16:07'!
defaultStructureClass
	^ PRComponent! !

!PRSettingsComponentCommand class methodsFor: 'testing' stamp: 'lr 4/18/2005 09:08'!
isAbstract
	^ false! !

!PRSettingsComponentCommand class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:48'!
label
	^ 'Settings'! !

!PRSettingsComponentCommand methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:19'!
accept: aVisitor
	aVisitor visitSettingsComponentCommand: self.! !

!PRSettingsComponentCommand methodsFor: 'accessing-delegated' stamp: 'lr 4/18/2005 09:12'!
description
	^ self structure componentClass description.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 10/21/2005 10:56'!
doAnswer
	super doAnswer.
	self context removeComponentAt: self structure.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:16'!
doExecute
	super doExecute.
	self structure settings: self settings.! !

!PRSettingsComponentCommand methodsFor: 'events' stamp: 'lr 4/18/2005 09:16'!
doInitialize
	super doInitialize.
	self settings: self structure settings.! !

!PRSettingsComponentCommand methodsFor: 'private' stamp: 'lr 9/21/2005 07:32'!
readUsing: aDescription
	^ self settings at: aDescription ifAbsent: [ aDescription default ].! !

!PRSettingsComponentCommand methodsFor: 'accessing' stamp: 'lr 4/18/2005 09:15'!
settings
	^ settings! !

!PRSettingsComponentCommand methodsFor: 'accessing' stamp: 'lr 4/18/2005 09:15'!
settings: aDictionary
	settings := aDictionary! !

!PRSettingsComponentCommand methodsFor: 'private' stamp: 'lr 9/21/2005 07:33'!
write: anObject using: aDescription
	self settings at: aDescription put: anObject.! !

!ByteArray methodsFor: '*pier-seaside' stamp: 'lr 4/17/2005 11:57'!
asMIMEDocument
	^ MIMEDocument content: self.! !

!WAHtmlRenderer methodsFor: '*pier-seaside' stamp: 'lr 11/17/2005 15:36'!
anchorToStructure: aStructure command: aCommand do: aBlock
	self
		anchorWithAction: [
			PRCurrentContext value: (PRCurrentContext value
				structure: aStructure command: aCommand) ]
		do: aBlock.! !

!WAHtmlRenderer methodsFor: '*pier-seaside' stamp: 'lr 4/17/2005 11:57'!
textPasswordOn: aSymbol of: anObject
	self passwordInputWithCallback: (self callbackForSelector: aSymbol of: anObject).! !

WASystemConfiguration subclass: #PRSeasideConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRSeasideConfiguration methodsFor: 'accessing-kernel' stamp: 'lr 11/17/2005 16:06'!
attributeKernel
	^ (WAListAttribute key: #kernel group: #pier) 
		options: PRKernel instances;
		yourself.! !

!PRSeasideConfiguration methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
attributes
	^ Array with: self attributeKernel.! !

PRStructure subclass: #PRComponent
	instanceVariableNames: 'componentClass settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Model'!

!PRComponent class methodsFor: 'accessing-resources' stamp: 'lr 9/5/2005 19:51'!
icon
	"SW2Compatibility compileFileNamed: 'icons/component.png' into: SW2Component class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 3 90 73 68 65 84 120 218 98 252 255 255 63 3 12 28 63 126 13 193 193 2 206 157 187 193 32 36 196 207 184 108 217 122 32 45 196 176 112 97 19 3 64 0 177 160 43 50 53 85 103 248 251 247 31 195 159 63 127 25 126 253 250 13 164 255 49 124 249 242 157 129 137 137 9 40 171 1 50 228 255 166 77 147 25 227 226 106 193 234 1 2 136 5 155 77 95 255 49 50 60 124 205 198 192 253 159 145 65 144 231 23 3 51 51 19 3 204 161 166 166 90 12 211 166 173 7 58 28 40 9 4 0 1 132 98 192 31 22 86 134 71 63 152 24 190 127 103 100 120 253 138 129 225 206 51 118 134 183 239 152 25 116 181 126 49 72 137 255 6 123 1 6 44 45 141 65 70 50 2 4 16 138 1 111 190 179 50 172 221 199 200 160 206 201 192 192 254 137 129 225 232 229 159 12 251 174 220 98 136 255 241 147 33 210 89 148 193 217 217 132 225 235 215 31 12 159 63 127 103 184 122 245 46 88 15 64 0 161 24 192 199 240 155 225 214 77 6 134 71 191 126 49 220 127 241 151 225 194 237 135 12 12 239 207 50 252 254 204 199 240 245 11 7 195 143 159 255 192 97 194 196 196 8 215 3 16 64 48 3 248 25 62 190 140 19 248 243 155 225 219 139 175 12 76 127 191 48 188 122 249 17 24 24 215 25 24 62 223 100 248 242 70 134 225 205 91 97 134 127 255 152 25 184 56 185 25 88 88 89 225 6 0 4 16 19 195 236 57 89 192 96 222 201 240 242 221 36 169 159 239 24 196 63 63 97 120 126 227 35 195 175 103 183 25 24 94 92 99 96 124 123 133 129 145 225 9 195 155 215 111 24 254 255 251 203 192 202 202 204 192 206 142 48 0 32 128 88 24 182 111 155 194 112 233 34 35 131 150 22 3 211 179 135 12 130 103 142 48 24 187 37 48 124 59 245 159 129 145 243 40 131 182 217 109 6 54 133 143 64 219 13 129 49 241 23 24 108 12 224 88 129 1 128 0 98 97 120 251 246 51 195 253 123 124 127 246 237 99 56 112 253 22 195 67 215 63 12 234 245 127 24 66 30 104 50 252 253 255 139 225 233 103 14 134 157 123 174 50 232 241 49 128 211 2 19 35 35 3 11 11 51 220 0 128 0 98 249 247 249 51 247 223 159 191 24 190 126 254 204 240 246 255 31 134 255 192 24 216 241 234 36 131 16 211 5 6 134 7 130 12 87 182 189 7 70 15 208 70 185 255 12 255 254 255 3 186 224 63 208 37 255 224 6 0 4 16 203 167 183 111 55 254 249 254 221 251 215 159 63 236 55 129 238 123 247 237 63 3 11 48 13 188 126 243 147 225 237 169 23 12 63 30 49 48 176 253 101 101 248 7 76 157 127 129 129 12 74 250 72 169 159 1 32 128 152 26 254 253 79 62 240 229 107 236 163 207 95 206 124 214 214 99 208 240 12 100 248 244 152 153 225 59 208 16 134 47 12 12 255 63 48 48 112 124 226 101 248 243 247 47 48 10 255 0 147 249 95 6 228 252 3 16 64 44 91 152 153 127 110 17 19 59 206 253 239 95 113 66 98 198 65 113 49 126 6 241 183 138 12 39 190 30 98 184 253 230 30 131 149 152 14 131 149 166 45 216 217 160 60 242 239 31 200 249 8 3 0 2 8 148 14 128 65 203 240 227 43 19 211 59 94 62 126 6 30 110 94 6 99 38 11 6 67 78 51 134 95 118 192 204 244 251 55 56 99 49 51 51 131 67 31 146 169 16 0 32 128 96 6 124 3 226 183 79 159 125 96 120 240 240 37 208 175 127 129 182 253 1 59 249 15 208 223 160 192 99 101 5 102 46 110 30 6 94 222 215 12 28 28 92 192 152 128 164 65 128 0 3 0 119 56 99 163 229 209 92 150 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PRComponent class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRComponent methodsFor: 'visiting' stamp: 'lr 10/20/2005 13:19'!
accept: aVisitor
	aVisitor visitComponent: self.! !

!PRComponent methodsFor: 'actions' stamp: 'lr 10/25/2005 23:45'!
component
	^ self componentClass ifNotNilDo: [ :class | 
		class new in: [ :component |
			self settings keysAndValuesDo: [ :description :value |
				component write: value using: description ].
			component ] ].! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 8/13/2005 12:50'!
componentClass
	^ componentClass ifNil: [ WAComponent ].! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
componentClass: aComponentClass
	componentClass := aComponentClass.
	self reset.! !

!PRComponent methodsFor: 'accessing-commands' stamp: 'lr 11/17/2005 15:42'!
editCommand
	^ PREditComponentCommand new.! !

!PRComponent methodsFor: 'initialize-release' stamp: 'lr 4/17/2005 11:57'!
initialize
	super initialize.
	self reset.! !

!PRComponent methodsFor: 'actions' stamp: 'lr 4/17/2005 11:57'!
reset
	self settings: Dictionary new.! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
settings
	^ settings! !

!PRComponent methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:57'!
settings: aDictionary 
	settings := aDictionary! !

!PRStructure methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/21/2005 11:14'!
environment
	^ self childrenDecoration
		at: 'Environment' 
		ifAbsent: [
			self isRoot
				ifFalse: [ self parent environment ]
				ifTrue: [ self error: 'No valid environment found.' ] ].! !

!PRStructure methodsFor: '*pier-seaside-testing' stamp: 'lr 11/14/2005 09:17'!
isValidView: aComponentClass in: aContext
	"Answer true if aComponentClass is a valid command in aContext."
	
	^ true! !

!PRStructure methodsFor: '*pier-seaside-configuration' stamp: 'lr 11/17/2005 16:09'!
viewComponentClass
	"Return the default view component class of the reciever."

	^ PRDefaultView.! !

!WACounter class methodsFor: '*pier-seaside-accessing-description' stamp: 'lr 5/8/2005 20:29'!
descriptionCount
	^ (MANumberDescription selector: #count label: 'Count' priority: 200)
		condition: [ :value | value isInteger ];
		beRequired;
		yourself.! !

!WACounter methodsFor: '*pier-seaside-accessing' stamp: 'lr 4/17/2005 11:57'!
count: anInteger
	count := anInteger! !

!WAAnchorTag methodsFor: '*pier-seaside-linking' stamp: 'lr 11/17/2005 15:36'!
goto: aContext
	"Initialize the receiver to properly activate aContext when being clicked. This includes a callback and a human-readable and bookmarkable url."

	| url |
	url := canvas context actionUrl copy.
	aContext structure parents allButFirst
		do: [ :each | url addToPath: each title ].
	url addParameter: 'command' value: aContext command class name.
	aContext command isView ifTrue: [ 
		url addParameter: 'view' value: aContext command viewComponentClass name ].
	url addParameter: (canvas callbacks 
		registerActionCallback: [ PRCurrentContext value: aContext ]).
	self url: url asString.! !

PRVisitor subclass: #PRRenderer
	instanceVariableNames: 'component html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

PRRenderer subclass: #PRDeepRenderer
	instanceVariableNames: 'visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRDeepRenderer methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
doesRemember: anObject
	visited size to: 1 by: -1 do: [ :index |
		(visited at: index) = anObject
			ifTrue: [ ^ true ] ].
	^ false.! !

!PRDeepRenderer methodsFor: 'private' stamp: 'lr 4/17/2005 11:58'!
remember: anObject while: aBlock
	visited addLast: anObject.
	aBlock ensure: [ visited removeLast ].! !

!PRDeepRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:58'!
start: anObject
	visited := OrderedCollection new.
	super start: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkBroken: anObject
	self visitLink: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkEmbed: anObject
	self visit: anObject target.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLinkGoto: anObject
	self visitLink: anObject.! !

!PRDeepRenderer methodsFor: 'visiting-links' stamp: 'lr 4/17/2005 11:58'!
visitInternalLink: anObject
	anObject isBroken
		ifTrue: [ self visitInternalLinkBroken: anObject ]
		ifFalse: [ 
			anObject isEmbedded
				ifFalse: [ self visitInternalLinkGoto: anObject ]
				ifTrue: [ 
					(self doesRemember: anObject target)
						ifTrue: [ self visitInternalLinkGoto: anObject ]
						ifFalse: [ 
							self
								remember: anObject target
								while: [ self visitInternalLinkEmbed: anObject ] ] ] ].! !

!PRDeepRenderer methodsFor: 'visiting-structure' stamp: 'lr 4/17/2005 11:58'!
visitStructure: anObject
	self visit: anObject document.! !

PRDeepRenderer subclass: #PRTocRenderer
	instanceVariableNames: 'enabled current counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRTocRenderer methodsFor: 'utilities' stamp: 'lr 4/17/2005 11:59'!
enable: aBoolean while: aBlock
	| old |
	old := enabled. enabled := aBoolean.
	aBlock ensure: [ enabled := old ].! !

!PRTocRenderer methodsFor: 'utilities' stamp: 'lr 4/17/2005 11:59'!
ifEnabledDo: aBlock 
	enabled ifTrue: [ aBlock value ].! !

!PRTocRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
level: anInteger
	| value |
	value := anInteger min: 6 max: 1.
	value < current ifTrue: [
		anInteger + 1 to: current do: [ :index |
			counter at: index put: 0 ] ].
	counter
		at: (current := value)
		put: (counter at: value) + 1.! !

!PRTocRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:59'!
start: anObject
	enabled := false. current := 1.
	counter := Array new: 6 withAll: 0.
	super start: anObject.! !

!PRTocRenderer methodsFor: 'visiting-document' stamp: 'lr 9/30/2005 20:38'!
visitHeader: anObject
	self level: anObject level.
	(counter first: current)
		do: [ :each | html render: each; text: '.' ].
	html space.
	html anchor
		url: '#' , anObject hash asString;
		with: [
			self 
				enable: true 
				while: [ super visitHeader: anObject ] ].
	html break.! !

!PRTocRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitText: anObject
	self ifEnabledDo: [ html text: anObject text ].! !

PRDeepRenderer subclass: #PRViewRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Renderer'!

!PRViewRenderer class methodsFor: 'as yet unclassified' stamp: 'lr 4/17/2005 12:00'!
component: aComponent structure: aStructure on: html
	^ self new
		component: aComponent;
		html: html;
		start: aStructure;
		yourself.! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:16'!
visitAnchor: anObject
	html anchor name: anObject name.! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 10/21/2005 10:55'!
visitComponent: anObject
	html render: (self context componentAt: anObject).! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 9/25/2005 11:12'!
visitExternalLink: anObject
	html cssClass: 'external'.
	html anchor
		url: anObject url;
		with: [ self visitLink: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 10/23/2005 19:40'!
visitFile: anObject
	| url |
	anObject isText
		ifTrue: [ html preformatted: anObject contents ]
		ifFalse: [
			url := html context 
				urlForDocument: anObject contents
				mimeType: anObject mimetype
				fileName: anObject filename.
			anObject file isImage
				ifTrue: [ html image url: url; altText: anObject title ]
				ifFalse: [ 
					anObject file isAudio | anObject file isVideo
						ifTrue: [ html embed: url do: anObject title ]
						ifFalse: [ html anchor url: url; with: anObject title ] ] ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:54'!
visitHeader: anObject
	html heading
		level: (6 min: anObject level + 1);
		with: [ 
			html anchor name: anObject hash.
			super visitHeader: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitHorizontalRule: anObject
	html horizontalRule.! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 9/30/2005 17:09'!
visitInternalLinkBroken: anObject
	self component in: [ :current |
		html anchor
			class: 'broken';
			callback: [ self create: anObject in: current ];
			with: [ self visitLink: anObject ] ].! !

!PRViewRenderer methodsFor: 'visiting-links' stamp: 'lr 10/25/2005 23:16'!
visitInternalLinkGoto: anObject
	html anchor
		class: 'internal';
		callback: [ self context: (self context structure: anObject target) ];
		with: [ self visitLink: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitLink: anObject
	anObject hasChildren
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ html render: anObject reference ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitListItem: anObject
	html listItem with: [ super visitListItem: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:19'!
visitOrderedList: anObject
	html orderedList with: [ super visitOrderedList: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-structure' stamp: 'lr 4/17/2005 11:59'!
visitPage: anObject
	self 
		remember: anObject
		while: [ super visitPage: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:16'!
visitParagraph: anObject
	html paragraph with: [ super visitParagraph: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitPreformatted: anObject
	html preformatted: [ 
		self
			visitAll: anObject children
			separatedBy: [ html text: Character cr ] ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitSmiley: anObject
	html image
		url: (html context 
			urlForDocument: (anObject class 
				smileyAt: anObject text 
				ifAbsent: [ ^ super visitSmiley: anObject ])
			mimeType: 'image/gif');
		altText: anObject text.! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 10/29/2005 22:17'!
visitTableCell: anObject
	html tableData
		style: (String streamContents: [ :stream |
			anObject align isNil ifFalse: [ 
				stream 
					nextPutAll: 'text-align: '; 
					nextPutAll: anObject align ] ]);
		with: [ super visitTableCell: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitTableRow: anObject
	html tableRow with: [ super visitTableRow: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitTable: anObject
	html table with: [ super visitTable: anObject ].! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 4/17/2005 11:59'!
visitText: anObject
	html html: anObject text.! !

!PRViewRenderer methodsFor: 'visiting-document' stamp: 'lr 9/25/2005 11:18'!
visitUnorderedList: anObject
	html unorderedList with: [ super visitUnorderedList: anObject ].! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
component
	^ component! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
component: aComponent
	component := aComponent! !

!PRRenderer methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:05'!
context
	^ PRCurrentContext value.! !

!PRRenderer methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:05'!
context: aContext
	PRCurrentContext value: aContext.! !

!PRRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:58'!
continue: anObject in: aComponent on: aRenderer
	| oldComponent oldRenderer |
	oldComponent := self component. 
	oldRenderer := self renderer.
	self component: aComponent.
	self renderer: aRenderer.
	[ self visit: anObject ] ensure: [ 
		self component: oldComponent.
		self renderer: oldRenderer ].! !

!PRRenderer methodsFor: 'actions' stamp: 'lr 11/17/2005 16:05'!
create: anInternalLink in: aComponent
	| lookup command |
	lookup := PRIncompletePathLookup 
		start: self context structure
		path: anInternalLink reference.
	command := PRAddCommand context: (self context 
		structure: lookup key).
	command title: lookup value.
	command := aComponent call: command asComponent.
	command isNil 
		ifTrue: [ ^ self ].
	self context: (command execute; answer).
	anInternalLink target: command answer structure.! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
renderer
	^ html! !

!PRRenderer methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
renderer: aRenderer
	html := aRenderer! !

!PRRenderer methodsFor: 'visiting' stamp: 'lr 4/17/2005 11:58'!
start: anObject in: aComponent on: aRenderer
	self component: aComponent.
	self renderer: aRenderer.
	self start: anObject.! !

!PRVisitor methodsFor: '*pier-seaside-visiting-structure' stamp: 'lr 10/21/2005 11:36'!
visitComponent: anObject
	self visitStructure: anObject.! !

!PRContext methodsFor: '*pier-seaside-private' stamp: 'lr 10/26/2005 00:08'!
buildComponentFor: aStructure
	^ aStructure component
		onChangeContext: self;
		yourself.! !

!PRContext methodsFor: '*pier-seaside-caching' stamp: 'lr 10/26/2005 00:07'!
componentAt: aStructure
	"Return the cached component of aStructure, if none is existing yet create a new one."

	^ self componentDictionary at: aStructure ifAbsentPut: [ self buildComponentFor: aStructure ].! !

!PRContext methodsFor: '*pier-seaside-private' stamp: 'lr 10/25/2005 23:38'!
componentDictionary
	^ self propertyAt: #components ifAbsentPut: [ Dictionary new ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 10/24/2005 09:04'!
components
	^ self componentDictionary values.! !

!PRContext methodsFor: '*pier-seaside-caching' stamp: 'lr 10/24/2005 09:06'!
removeComponentAt: aStructure
	"Remove any cached component for aStructure."

	^ self componentDictionary removeKey: aStructure ifAbsent: [ ].! !

!PRContext methodsFor: '*pier-seaside-accessing' stamp: 'lr 11/17/2005 15:42'!
renderer
	^ self propertyAt: #renderer ifAbsentPut: [ PRViewRenderer new ].! !

!MAComponent methodsFor: '*pier-seaside-accessing' stamp: 'lr 11/17/2005 15:17'!
context
	^ PRCurrentContext value.! !

!MAComponent methodsFor: '*pier-seaside-accessing' stamp: 'lr 11/17/2005 15:17'!
context: aContext
	PRCurrentContext value: aContext.! !

MAComponent subclass: #PRSeasideFrame
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRSeasideFrame class methodsFor: 'instance creation' stamp: 'lr 4/17/2005 11:59'!
context: aContext
	"This contructor creates a new SmallWiki frame that can be used within any Seaside application. It doesn't require a special session class, since all the required state is hold in the context of the wiki itself."

	^ self new
		context: aContext;
		yourself.! !

!PRSeasideFrame class methodsFor: 'class initialization' stamp: 'lr 11/17/2005 16:06'!
initialize
	| kernel |
	(PRCompatibility confirm: 'Would you like to create a Seaside application for Pier?') ifTrue: [
		(PRKernel instances isEmpty or: [ PRCompatibility confirm: 'Would you like to create a new Pier kernel?' ]) ifTrue: [ 
			(PRCompatibility request: 'Please enter the name of your Pier kernel:' default: 'default')
				ifNotNilDo: [ :value | kernel := PRKernel named: value ] ].
		(PRKernel instances notEmpty and: [ kernel isNil ]) ifTrue: [
			kernel := PRCompatibility choose: 'Select the Pier kernel you would like to use:' from: PRKernel instances ].
		kernel notNil ifTrue: [
			(PRCompatibility request: 'Enter the entry point:' default: 'pier') ifNotNilDo: [ :path |
				PRCompatibility inform: 'Your Pier-Application is running on: ' , (self registerAsApplication: path kernel: kernel) baseUrl asString ] ] ].
	self initializeEnvironment.! !

!PRSeasideFrame class methodsFor: 'class initialization' stamp: 'lr 11/17/2005 16:07'!
initializeEnvironment
	| page |
	PRKernel instances do: [ :kernel |
		page := kernel root childrenDecoration
			at: 'Environment' 
			ifAbsent: nil.
		page notNil 
			ifTrue: [ page remove ].
		page := PRPage new
			title: 'Environment';
			yourself.
		page childrenDecoration
			add: ((PRComponent new title: 'Header')
				componentClass: PRHeaderWidget;
				yourself);
			add: ((PRComponent new title: 'Views')
				componentClass: PRViewsWidget;
				yourself);
			add: ((PRComponent new title: 'Commands')
				componentClass: PRCommandsWidget;
				yourself);
			add: ((PRComponent new title: 'Tree')
				componentClass: PRTreeWidget;
				yourself);
			add: ((PRComponent new title: 'Contents')
				componentClass: PRContentsWidget;
				yourself).
		page contents: '+Header+
<table class="body"><tr><td class="boxes">+Views+<br />+Commands+<br />+Tree+</td><td class="spacer"></td><td class="contents">+Contents+</td></tr></table>
<div align="right">Pier &mdash; Empowered by Seaside</div>'.
		kernel root childrenDecoration add: page ].! !

!PRSeasideFrame class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:26'!
isAbstract
	^ false! !

!PRSeasideFrame class methodsFor: 'registration' stamp: 'lr 11/17/2005 16:07'!
registerAsApplication: aString kernel: aKernel	
	| application |
	application := self registerAsApplication: aString.
	application configuration addAncestor: PRSeasideConfiguration localConfiguration.
	^ application
		preferenceAt: #mainClass put: PRSeasideMain;
		preferenceAt: #kernel put: aKernel;
		yourself.! !

!PRSeasideFrame methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
children
	^ self context components.! !

!PRSeasideFrame methodsFor: 'processing' stamp: 'lr 10/25/2005 23:13'!
childrenDo: aStream
	self withContextDo: [ super childrenDo: aStream ].! !

!PRSeasideFrame methodsFor: 'accessing' stamp: 'lr 9/30/2005 17:20'!
context
	^ context! !

!PRSeasideFrame methodsFor: 'accessing' stamp: 'lr 10/25/2005 23:10'!
context: aContext
	context := aContext.
	self visiblePresentersDo: [ :each | each onChangeContext: aContext ].! !

!PRSeasideFrame methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
environment
	^ self context structure environment.! !

!PRSeasideFrame methodsFor: 'rendering' stamp: 'lr 11/11/2005 17:23'!
renderContentOn: html
	html div 
		class: 'frame';
		with: [
			self context renderer
				start: self environment
				in: self on: html ].! !

!PRSeasideFrame methodsFor: 'processing' stamp: 'lr 10/25/2005 23:01'!
renderWithContext: aContext
	self withContextDo: [ super renderWithContext: aContext ].! !

!PRSeasideFrame methodsFor: 'updating' stamp: 'lr 4/19/2005 21:10'!
style
	^ '@import "http://www.lukas-renggli.ch/sw2/style.css";'
! !

!PRSeasideFrame methodsFor: 'updating' stamp: 'lr 11/17/2005 16:06'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot docType: '<?xml version="1.0" encoding="UTF-8"?><!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'.
	aHtmlRoot htmlAttributes at: 'xmlns' put: 'http://www.w3.org/1999/xhtml'.
	aHtmlRoot addHeadElement: ((WAHtmlElement named: 'meta')
		attributeAt: 'name' put: 'generator';
		attributeAt: 'content' put: PRDistribution basicNew versionString;
		yourself).! !

!PRSeasideFrame methodsFor: 'updating' stamp: 'lr 11/11/2005 17:22'!
updateUrl: anUrl
	super updateUrl: anUrl.
	self context structure parents allButFirst 
		do: [ :each | anUrl path add: each title ].! !

!PRSeasideFrame methodsFor: 'private' stamp: 'lr 11/17/2005 16:06'!
withContextDo: aBlock
	^ PRCurrentContext use: self during: aBlock.! !

MAComponent subclass: #PRViewComponent
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

PRViewComponent subclass: #PRDefaultView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRDefaultView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:27'!
isAbstract
	^ false! !

!PRDefaultView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'View'! !

!PRDefaultView methodsFor: 'rendering' stamp: 'lr 10/25/2005 22:38'!
renderContentOn: html
	self context renderer 
		continue: self context structure 
		in: self on: html.! !

PRViewComponent subclass: #PRHistoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRHistoryView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:27'!
isAbstract
	^ false! !

!PRHistoryView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'History'! !

!PRHistoryView methodsFor: 'actions' stamp: 'lr 10/24/2005 11:26'!
open: aCommand
	self context: (self context command: aCommand).! !

!PRHistoryView methodsFor: 'rendering' stamp: 'lr 10/29/2005 21:58'!
renderContentOn: html
	html table: [
		self context kernel persistency 
			for: self context structure max: 20
			do: [ :each | 
				html tableRow: [
					html tableData: each label.
					html tableData: each timestamp.
					html tableData: (each description toString: each).
					html tableData: [
						html anchor 
							callback: [ self open: each ];
							with: 'Open' ] ] ]
			ifNone: [ html render: 'No history available' ] ].! !

PRViewComponent subclass: #PRRawView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

PRRawView subclass: #PRDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRDownloadView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:28'!
isAbstract
	^ false! !

!PRDownloadView class methodsFor: 'testing' stamp: 'lr 11/17/2005 15:44'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isKindOf: PRFile ].! !

!PRDownloadView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Download'! !

!PRDownloadView methodsFor: 'rendering' stamp: 'lr 10/23/2005 19:28'!
renderContentOn: aRequest
	self context structure file in: [ :file |
		aRequest 
			contentType: file mimetype;
			attachmentWithFileName: file filename;
			nextPutAll: file contents ].! !

!PRRawView methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:57'!
renderWithContext: aRenderingContext
	| response |
	self renderContentOn: (response := WAResponse new).
	self session returnResponse: response.! !

PRRawView subclass: #PRWikiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-View'!

!PRWikiView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:28'!
isAbstract
	^ false! !

!PRWikiView class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:42'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure hasDocument ].! !

!PRWikiView class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Wiki'! !

!PRWikiView methodsFor: 'rendering' stamp: 'lr 11/17/2005 15:36'!
renderContentOn: aRequest
	aRequest contentType: 'text/wiki'.
	PRDocumentWriter 
		visit: self context structure document 
		on: aRequest stream.! !

!PRViewComponent class methodsFor: 'testing' stamp: 'lr 11/14/2005 09:15'!
isValidIn: aContext
	"Verify that a view as a meaning for the context aContext. Override this message, to add new tests, but do not forget to call this super implementation."
	
	^ aContext structure isValidView: self in: aContext.! !

!PRViewComponent class methodsFor: 'instance-creation' stamp: 'lr 10/21/2005 13:13'!
on: aContext
	^ self new
		setContext: aContext;
		yourself.! !

!PRViewComponent methodsFor: 'accessing' stamp: 'lr 11/1/2005 22:48'!
context
	^ context! !

!PRViewComponent methodsFor: 'rendering' stamp: 'lr 10/21/2005 13:16'!
renderContentOn: html
	html strong: self context.! !

!PRViewComponent methodsFor: 'initialize' stamp: 'lr 10/21/2005 13:13'!
setContext: aContext
	context := aContext! !

MAComponent subclass: #PRWidget
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRWidget subclass: #PRContentsWidget
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRContentsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'contents'! !

!PRContentsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultTitle
	^ '%c'! !

!PRContentsWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRContentsWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Contents'! !

!PRContentsWidget methodsFor: 'private' stamp: 'lr 10/26/2005 00:05'!
buildComponent
	^ self context command asComponent
		onAnswer: [ :value | self onAnswerComponent: value ];
		yourself.! !

!PRContentsWidget methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:58'!
children
	^ Array with: self component.! !

!PRContentsWidget methodsFor: 'accessing' stamp: 'lr 10/26/2005 00:04'!
component
	^ component ifNil: [ component := self buildComponent ].! !

!PRContentsWidget methodsFor: 'accessing' stamp: 'lr 10/21/2005 13:30'!
component: aComponent
	component := aComponent! !

!PRContentsWidget methodsFor: 'initialization' stamp: 'lr 9/30/2005 20:16'!
initialize
	super initialize.
	self session registerObjectForBacktracking: self.! !

!PRContentsWidget methodsFor: 'events' stamp: 'lr 10/25/2005 23:26'!
onAnswerComponent: aCommand
	 self context: (aCommand notNil
		ifTrue: [ aCommand execute; answer ]
		ifFalse: [ self context structure: self context structure ]).! !

!PRContentsWidget methodsFor: 'events' stamp: 'lr 10/26/2005 00:04'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self component: self buildComponent.! !

!PRContentsWidget methodsFor: 'rendering' stamp: 'lr 4/17/2005 11:58'!
renderWidgetOn: html
	html render: self component.! !

!PRContentsWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 17:44'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: self context structure title.! !

PRWidget subclass: #PRListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRListWidget subclass: #PRCommandsWidget
	instanceVariableNames: 'commandClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRCommandsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/17/2005 15:42'!
defaultCommandClasses
	^ (Array withAll: PRCommand withAllConcreteClasses) 
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself.! !

!PRCommandsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box commands'! !

!PRCommandsWidget class methodsFor: 'accessing-description' stamp: 'lr 11/17/2005 15:42'!
descriptionCommandClasses
	^ (MAMultipleOptionDescription selector: #commandClasses label: 'Command Classes' priority: 200)
		options: (MADynamicObject on: [ PRCommand withAllConcreteClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PRCommandsWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRCommandsWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Commands'! !

!PRCommandsWidget methodsFor: 'accessing-settings' stamp: 'lr 4/24/2005 11:57'!
commandClasses
	^ commandClasses ifNil: [ commandClasses := self class defaultCommandClasses ].! !

!PRCommandsWidget methodsFor: 'accessing-settings' stamp: 'lr 4/18/2005 09:23'!
commandClasses: aCollection
	commandClasses := aCollection! !

!PRCommandsWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:45'!
items
	| command |
	^ Array streamContents: [ :stream |
		self context allCommandClasses in: [ :commands |
			self commandClasses do: [ :class |
				command := commands
					detect: [ :each | 
						each = class
							or: [ each inheritsFrom: class ] ]
					ifNone: [ nil ].
				command isNil 
					ifFalse: [ stream nextPut: command ] ] ] ].! !

!PRCommandsWidget methodsFor: 'rendering' stamp: 'lr 10/29/2005 21:58'!
renderItem: aClass on: html
	html anchor 
		goto: (self context 	
			structure: self context structure 
			command: aClass new);
		text: aClass label.! !

!PRCommandsWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:45'!
selected
	^ self context command class.! !

PRCommandsWidget subclass: #PRHeaderWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/17/2005 15:52'!
defaultCommandClasses
	^ OrderedCollection
		with: PRViewCommand 
		with: PREditCommand.! !

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'header'! !

!PRHeaderWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultTitle
	^ '%r'! !

!PRHeaderWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 22:26'!
label
	^ 'Header'! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:08'!
renderLogoOn: html
	html tableData class: 'logo'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:08'!
renderSpacerOn: html
	html tableData class: 'spacer'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:48'!
renderTabsOn: html
	self renderItems: self items reversed on: html.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:41'!
renderTitleOn: html
	html tableData class: 'start'.
	html tableData class: 'title'; with: (self expand: self title).
	html tableData class: 'tabs'; with: [ self renderTabsOn: html ].
	html tableData class: 'end'.! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 18:10'!
renderWidgetOn: html
	html table
		class: 'header'; 
		with: [
			self renderLogoOn: html.
			self renderSpacerOn: html.
			self renderTitleOn: html ].! !

!PRHeaderWidget methodsFor: 'rendering' stamp: 'lr 4/17/2005 11:58'!
renderWidgetTitleOn: html! !

!PRListWidget methodsFor: 'accessing' stamp: 'lr 11/1/2005 22:27'!
items
	self subclassResponsibility.! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 16:43'!
renderItems: aCollection on: html
	html unorderedList with: [
		aCollection do: [ :each | 
			html listItem
				class: (self selected = each ifTrue: [ 'active' ]);
				with: [ self renderItem: each on: html ] ] ].! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:41'!
renderItem: anObject on: html
	html render: anObject.! !

!PRListWidget methodsFor: 'rendering' stamp: 'lr 9/30/2005 19:39'!
renderWidgetOn: html
	self renderItems: self items on: html.! !

!PRListWidget methodsFor: 'accessing' stamp: 'lr 11/2/2005 21:55'!
selected
	self subclassResponsibility.! !

PRListWidget subclass: #PRStructuresWidget
	instanceVariableNames: 'filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

PRStructuresWidget subclass: #PRChildrenWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRChildrenWidget class methodsFor: 'accessing-defaults' stamp: 'lr 9/5/2005 20:02'!
defaultCssClass
	^ 'box children'! !

!PRChildrenWidget class methodsFor: 'testing' stamp: 'lr 9/5/2005 20:03'!
isAbstract
	^ false! !

!PRChildrenWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Children'! !

!PRChildrenWidget methodsFor: 'testing' stamp: 'lr 9/30/2005 19:42'!
isVisible
	^ self context structure hasChildren.! !

!PRChildrenWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:42'!
items
	^ self context structure children.! !

PRStructuresWidget subclass: #PRPathWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRPathWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box path'! !

!PRPathWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRPathWidget class methodsFor: 'accessing' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Path'! !

!PRPathWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:43'!
items
	^ self context structure parents.! !

PRStructuresWidget subclass: #PRReferencesWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRReferencesWidget class methodsFor: 'accessing-defaults' stamp: 'lr 11/1/2005 07:16'!
defaultCssClass
	^ 'box references'! !

!PRReferencesWidget class methodsFor: 'testing' stamp: 'lr 11/1/2005 07:17'!
isAbstract
	^ false! !

!PRReferencesWidget class methodsFor: 'accessing' stamp: 'lr 11/1/2005 07:18'!
label
	^ 'References'! !

!PRReferencesWidget methodsFor: 'testing' stamp: 'lr 11/1/2005 07:19'!
isVisible
	^ self items notEmpty.! !

!PRReferencesWidget methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:05'!
items
	^ (PRReferences from: self context root to: self context structure)
		collect: [ :each | each owner ].! !

PRStructuresWidget subclass: #PRSearchWidget
	instanceVariableNames: 'query'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRSearchWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 11:59'!
defaultCssClass
	^ 'box search'! !

!PRSearchWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 11:59'!
isAbstract
	^ false! !

!PRSearchWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Search'! !

!PRSearchWidget methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:06'!
items
	^ [ PRQueryVisitor start: self context root string: self query ]
		ifCurtailed: [ Array new ].! !

!PRSearchWidget methodsFor: 'accessing-properties' stamp: 'lr 10/30/2005 01:38'!
query
	^ query ifNil: [ query := String new ].! !

!PRSearchWidget methodsFor: 'accessing-properties' stamp: 'lr 10/30/2005 01:38'!
query: aString
	query := aString! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 10/30/2005 13:39'!
renderQueryOn: html
	html form: [
		html textInput
			id: (self ajaxId: #query);
			style: 'width: 95%';
			value: self query;
			callback: [ :value | self query: value ];
			in: [ :tag |
				self hasScriptaculous ifTrue: [
					tag onEnter: (html ajax
						id: (self ajaxId: #result);
						addParameter: (SUFormElement new 
							id: (self ajaxId: #query); 
							serialize);
						on: #renderResultOn: of: self) ] ] ].! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 10/30/2005 01:56'!
renderResultOn: html
	self items in: [ :collection |
		collection isEmpty 
			ifTrue: [ html span with: '' ]
			ifFalse: [
				html div style: 'height: 6px'.
				self renderItems: self items on: html ] ].! !

!PRSearchWidget methodsFor: 'rendering' stamp: 'lr 10/30/2005 01:33'!
renderWidgetOn: html
	self renderQueryOn: html.
	html div
		id: (self ajaxId: #result);
		with: [ self renderResultOn: html ].! !

!PRStructuresWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 22:32'!
defaultFilter
	^ Array new.! !

!PRStructuresWidget class methodsFor: 'accessing-defaults' stamp: 'lr 9/5/2005 19:59'!
defaultShowIcons
	^ true! !

!PRStructuresWidget class methodsFor: 'accessing-description' stamp: 'lr 11/17/2005 16:09'!
descriptionFilter
	^ (MAMultipleOptionDescription selector: #filter label: 'Filter' priority: 210 default: self defaultFilter)
		componentClass: MACheckboxGroupComponent;
		options: (MADynamicObject on: [ PRStructure withAllConcreteClasses ]);
		reference: MAClassDescription new;
		beSorted;
		yourself.! !

!PRStructuresWidget class methodsFor: 'accessing-description' stamp: 'lr 9/5/2005 19:59'!
descriptionShowIcons
	^ MABooleanDescription selector: #showIcons label: 'Show Icons' priority: 200 default: self defaultShowIcons.! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 10/31/2005 18:03'!
filter
	^ filter ifNil: [ filter := self class defaultFilter ].! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 10/29/2005 22:32'!
filter: aCollection
	filter := aCollection! !

!PRStructuresWidget methodsFor: 'testing' stamp: 'lr 10/29/2005 22:39'!
isFiltered: aStructure
	^ self filter anySatisfy: [ :each | aStructure isKindOf: each ].! !

!PRStructuresWidget methodsFor: 'accessing' stamp: 'lr 10/29/2005 22:39'!
items
	^ super items reject: [ :each | self isFiltered: each ].! !

!PRStructuresWidget methodsFor: 'rendering' stamp: 'lr 10/29/2005 21:59'!
renderItem: aStructure on: html
	self showIcons ifTrue: [
		html image
			url: (html context 
				urlForDocument: aStructure icon 
				mimeType: 'image/png');
			altText: aStructure class label ].
	html anchor
		class: (self selected = aStructure 
			ifTrue: [ 'active' ]);
		goto: (self context structure: aStructure);
		text: aStructure title.! !

!PRStructuresWidget methodsFor: 'accessing' stamp: 'lr 9/30/2005 19:41'!
selected
	^ self context structure.! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 9/5/2005 20:00'!
showIcons
	^ self propertyAt: #showIcons ifAbsent: [ self class defaultShowIcons ].! !

!PRStructuresWidget methodsFor: 'accessing-settings' stamp: 'lr 9/5/2005 20:00'!
showIcons: aBoolean
	self propertyAt: #showIcons put: aBoolean.! !

PRStructuresWidget subclass: #PRTreeWidget
	instanceVariableNames: 'expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultAutoCollapse
	^ true! !

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultAutoExpand
	^ true! !

!PRTreeWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssClass
	^ 'box tree'! !

!PRTreeWidget class methodsFor: 'accessing-description' stamp: 'lr 10/21/2005 17:34'!
descriptionAutoCollapse
	^ MABooleanDescription selector: #autoCollapse label: 'Auto Collapse' priority: 310 default: self defaultAutoCollapse.! !

!PRTreeWidget class methodsFor: 'accessing-description' stamp: 'lr 10/21/2005 17:34'!
descriptionAutoExpand
	^ MABooleanDescription selector: #autoExpand label: 'Auto Expand' priority: 300 default: self defaultAutoExpand.! !

!PRTreeWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRTreeWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:06'!
label
	^ 'Tree'! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoCollapse
	^ self propertyAt: #autoCollapse ifAbsent: [ self class defaultAutoCollapse ].! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoCollapse: aBoolean
	self propertyAt: #autoCollapse put: aBoolean.! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoExpand
	^ self propertyAt: #autoExpand ifAbsent: [ self class defaultAutoExpand ].! !

!PRTreeWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
autoExpand: aBoolean
	self propertyAt: #autoExpand put: aBoolean.! !

!PRTreeWidget methodsFor: 'private' stamp: 'lr 10/29/2005 22:41'!
childrenOf: aStructure
	^ aStructure children reject: [ :each | self isFiltered: each ].! !

!PRTreeWidget methodsFor: 'actions' stamp: 'lr 10/21/2005 17:42'!
collapseStructure: aStructure
	expanded remove: aStructure.! !

!PRTreeWidget methodsFor: 'actions' stamp: 'lr 10/21/2005 17:43'!
expandStructure: aStructure
	expanded add: aStructure.! !

!PRTreeWidget methodsFor: 'initialization' stamp: 'lr 10/21/2005 16:45'!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := Set new).! !

!PRTreeWidget methodsFor: 'testing' stamp: 'lr 10/21/2005 16:49'!
isExpanded: aNode
	^ expanded includes: aNode.! !

!PRTreeWidget methodsFor: 'accessing' stamp: 'lr 10/21/2005 17:08'!
items
	self shouldNotImplement! !

!PRTreeWidget methodsFor: 'events' stamp: 'lr 10/21/2005 17:47'!
onChangeContext: aContext
	super onChangeContext: aContext.
	self autoCollapse
		ifTrue: [ expanded removeAll: expanded copy ]. 
	self autoExpand
		ifTrue: [ expanded addAll: aContext structure parents ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/29/2005 22:41'!
renderStructureButton: aStructure on: html
	| isExpanded |
	html span 
		class: 'button';
		with: [
			(self childrenOf: aStructure) notEmpty ifTrue: [
				isExpanded := self isExpanded: aStructure.
				html anchor
					callback: [ 
						isExpanded 
							ifTrue: [ self collapseStructure: aStructure ]
							ifFalse: [ self expandStructure: aStructure ] ];
					with: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ]) ] ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/29/2005 22:42'!
renderStructureChildren: aStructure on: html
	| children |
	(self isExpanded: aStructure)
		ifFalse: [ ^ self ].
	children := self childrenOf: aStructure.
	children isEmpty ifTrue: [ ^ self ].
	html unorderedList: [
		children do: [ :each |
			self renderStructure: each on: html ] ].! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/21/2005 16:51'!
renderStructureLabel: aStructure on: html
	self renderItem: aStructure on: html.! !

!PRTreeWidget methodsFor: 'rendering-items' stamp: 'lr 10/21/2005 17:45'!
renderStructure: aStructure on: html
	html listItem: [
		self renderStructureButton: aStructure on: html.
		self renderStructureLabel: aStructure on: html.
		self renderStructureChildren: aStructure on: html ].! !

!PRTreeWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:21'!
renderWidgetOn: html
	html unorderedList: [ self renderStructure: self context root on: html ].! !

PRListWidget subclass: #PRViewsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRViewsWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/21/2005 15:36'!
defaultCssClass
	^ 'box views'! !

!PRViewsWidget class methodsFor: 'testing' stamp: 'lr 10/21/2005 15:34'!
isAbstract
	^ false! !

!PRViewsWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Views'! !

!PRViewsWidget methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:37'!
items
	^ PRViewComponent withAllConcreteClasses
		select: [ :each | each isValidIn: self context ].! !

!PRViewsWidget methodsFor: 'rendering' stamp: 'lr 11/17/2005 15:37'!
renderItem: aClass on: html
	html anchor
		goto: (self context 
			command: (PRViewCommand new
				viewComponentClass: aClass;
				yourself));
		with: aClass label.! !

!PRViewsWidget methodsFor: 'accessing' stamp: 'lr 10/21/2005 14:37'!
selected
	^ self context command isView
		ifTrue: [ self context command viewComponent class ].! !

PRWidget subclass: #PRTocWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Widgets'!

!PRTocWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssClass
	^ 'box toc'! !

!PRTocWidget class methodsFor: 'testing' stamp: 'lr 4/17/2005 12:00'!
isAbstract
	^ false! !

!PRTocWidget class methodsFor: 'converting' stamp: 'lr 10/29/2005 21:07'!
label
	^ 'Table of Contents'! !

!PRTocWidget methodsFor: 'rendering' stamp: 'lr 11/17/2005 16:19'!
renderWidgetOn: html
	PRTocRenderer new
		start: self context structure document
		in: self on: html.! !

!PRWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssClass
	^ String new.! !

!PRWidget class methodsFor: 'accessing-defaults' stamp: 'lr 4/17/2005 12:00'!
defaultCssName
	^ String new.! !

!PRWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/29/2005 22:00'!
defaultTitle
	^ self label.! !

!PRWidget class methodsFor: 'accessing-description' stamp: 'lr 4/17/2005 12:00'!
descriptionCssClass
	^ MAStringDescription selector: #cssClass label: 'CSS Class' priority: 120 default: self defaultCssClass.! !

!PRWidget class methodsFor: 'accessing-description' stamp: 'lr 4/17/2005 12:00'!
descriptionCssName
	^ MAStringDescription selector: #cssName label: 'CSS Name' priority: 110 default: self defaultCssName.! !

!PRWidget class methodsFor: 'accessing-description' stamp: 'lr 4/17/2005 12:00'!
descriptionTitle
	^ MAStringDescription selector: #title label: 'Title' priority: 100 default: self defaultTitle.! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
cssClass
	^ self propertyAt: #cssClass ifAbsent: [ self class defaultCssClass ].! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
cssClass: aString
	self propertyAt: #cssClass put: aString.! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
cssName
	^ self propertyAt: #cssName ifAbsent: [ self class defaultCssName ].! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
cssName: aString
	self propertyAt: #cssName put: aString.! !

!PRWidget methodsFor: 'private' stamp: 'lr 11/17/2005 15:36'!
expand: aString
	^ PRMacroExpander default value: aString value: self context.! !

!PRWidget methodsFor: 'testing' stamp: 'lr 9/5/2005 20:19'!
isVisible
	"Return true if the receiver is visible. Some subclasses might want to override this message to hide the reciever in certain cases."
	
	^ true.! !

!PRWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^ properties.! !

!PRWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey
	^ self properties at: aKey.! !

!PRWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey ifAbsentPut: aBlock
	^ self properties at: aKey ifAbsentPut: aBlock.! !

!PRWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock.! !

!PRWidget methodsFor: 'accessing-properties' stamp: 'lr 4/17/2005 11:59'!
propertyAt: aKey put: aValue
	^ self properties at: aKey put: aValue.! !

!PRWidget methodsFor: 'rendering' stamp: 'lr 10/21/2005 17:42'!
renderContentOn: html
	self isVisible
		ifFalse: [ ^ self ].
	html div
		id: self cssName;
		class: self cssClass;
		with: [ 
			self 
				renderWidgetTitleOn: html; 
				renderWidgetOn: html ].! !

!PRWidget methodsFor: 'rendering' stamp: 'lr 5/9/2005 10:04'!
renderWidgetOn: html
	self subclassResponsibility.! !

!PRWidget methodsFor: 'rendering' stamp: 'lr 4/17/2005 11:59'!
renderWidgetTitleOn: html
	self title isEmptyOrNil
		ifFalse: [ html heading: (self expand: self title) ].! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
title
	^ self propertyAt: #title ifAbsent: [ self class defaultTitle ].! !

!PRWidget methodsFor: 'accessing-settings' stamp: 'lr 4/17/2005 11:59'!
title: aString
	self propertyAt: #title put: aString.! !

WARenderLoopMain subclass: #PRSeasideMain
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRSeasideMain methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
context
	^ context! !

!PRSeasideMain methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
context: aContext
	context := aContext! !

!PRSeasideMain methodsFor: 'processing' stamp: 'lr 10/25/2005 23:34'!
createRoot
	^ super createRoot
		context: self context;
		yourself.! !

!PRSeasideMain methodsFor: 'private' stamp: 'lr 11/17/2005 16:07'!
fetchContext: aRequest
	^ PRContext 
		kernel: self kernel
		structure: (self fetchStructure: aRequest).! !

!PRSeasideMain methodsFor: 'private' stamp: 'lr 11/17/2005 16:07'!
fetchStructure: aRequest
	| path |
	path := (aRequest url beginsWith: self application basePath)
		ifTrue: [ aRequest url allButFirst: self application basePath size ]
		ifFalse: [ aRequest url ].
	^ PRPathLookup
		start: self kernel root 
		path: path.! !

!PRSeasideMain methodsFor: 'processing' stamp: 'lr 4/17/2005 11:59'!
kernel
	^ self application preferenceAt: #kernel.! !

!PRSeasideMain methodsFor: 'processing' stamp: 'lr 4/17/2005 11:59'!
start: aRequest
	self context: (self fetchContext: aRequest).
	super start: aRequest.! !

WAStyleLibrary subclass: #PRStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Core'!

!PRStyles class methodsFor: 'accessing-defaults' stamp: 'dc 8/18/2005 13:59'!
defaultBasic
	^ '* {
	margin: 0px;
	padding: 0px;
}

body { 
	font-family: Veranda, Arial, Helvetica, sans-serif;
	font-size: 12px;
	color: #111111;
	margin: 10px;
}

img {
	border: none; 
}

td, 
th { 
	text-align: left; 
	vertical-align: top; 
}

a {
	text-decoration: none; 
	color: #092565; 
}

a:hover {
	text-decoration: underline;
}'.! !

!PRStyles class methodsFor: 'accessing-defaults' stamp: 'dc 8/18/2005 13:58'!
defaultBox
	^ '.box {
	max-width: 1000px;
	display: block;
	padding-left: 10px;
	background: url(box-contents.png) right repeat-y;
}
.box:before {
	display: block;
	line-height: 0px;
	margin-left: -10px;
	background: url(box-top-right.png) top right no-repeat;
	content: url(box-top-left.png);
}
.box:after {
	display: block;
	line-height: 0px;
	margin-left: -10px;
	background: url(box-bottom-right.png) bottom right no-repeat;
	content: url(box-bottom-left.png);
}

.box h1 { 
	font-size: 110%; margin-bottom: 0.5em; 
}
.box a { 
	text-decoration: none; 
}
.box .active { 
	font-weight: bold; 
}
.box li { 
	list-style: none; 
}
.box ul li li { 
	margin-left: 20px; 
}

.box .tree .button { 
	margin-right: 3px; 
}

.box .search input[type=text] { 
	width: 100px; 
}
.box .search input[type=submit] { 
	width: 50px; 
}'.! !

!PRStyles class methodsFor: 'accessing-defaults' stamp: 'dc 8/18/2005 13:56'!
defaultContents
	^ '.contents h1 { 
	font-size: 250%; 
	margin-bottom: 0.5em; 
}
.contents h2 { 
	font-size: 180%; 
	margin-top: 1em; 
	margin-bottom: 0.5em; 
}
.contents h3 { 
	font-size: 160%; 
	margin-top: 1em; 
	margin-bottom: 0.5em; 
}
.contents h4 { 
	font-size: 140%; 
	margin-top: 1em; 
	margin-bottom: 0.5em; 
}
.contents h5 { 
	font-size: 120%; 
	margin-top: 1em; 
	margin-bottom: 0.5em; 
}
.contents h6 { 
	font-size: 100%; 
	margin-top: 1em; 
	margin-bottom: 0.5em; 
}
.contents p { 
	margin-bottom: 1em; 
	line-height: 1.2em; 
}
.contents ul { 
	margin-bottom: 1em; 
}
.contents ol { 
	margin-bottom: 1em; 
}
.contents li { 
	margin-left: 20px; 
	line-height: 1.2em; 
}
.contents pre { 
	font-family: Courier, Courier New, Sans Serif;
	border: #092565 dashed 1px; 
	background-color: #E7EBF2; 
	padding: 0.5em;
	margin-bottom: 1em;
}
.contents textarea {
	width: 500px; 
	height: 300px; 
}
.contents table td { 
	padding: 3px; 
}
.contents .form th { 
	padding-top: 6px;
	padding-right: 10px;
}
.contents .form .required {
	color: #aa0000;
	font-weight: bold;
}
.contents .form input, 
.contents .buttons input { 
	margin-right: 6px; 
}
.contents .buttons {
	margin-top: 5px;
}
.contents .broken, 
.contents .exceptions .exception { 
	color: #aa0000;
}'.! !

!PRStyles class methodsFor: 'accessing-defaults' stamp: 'dc 8/18/2005 13:57'!
defaultLayout
	^ '/* frame */
.frame {
	max-width: 900px;
	margin: 0px auto;
}	

/* header table (ugly) */
.header {
	width: 100%; height: 127px;
	border-collapse: collapse;
	border-spacing: 0px;
	margin-bottom: 10px;
}

.header .logo {
	background: transparent url(header-logo.png) no-repeat;
	width: 127px; height: 127px;
}

.header .spacer {
	width: 10px;
}

.header .start {
	background: transparent url(header-title-left.png) no-repeat;
	width: 11px; height: 127px;
}

.header .title {
	background: transparent url(header-title.png) repeat-x;
	vertical-align: bottom;
	color: white;
	font-size: 500%;
	font-weight: bold;
}

.header .tabs {
	width: 250px;
	background: transparent url(header-title.png) repeat-x;
	vertical-align: bottom;
}

.header .tabs ul {
	list-style: none;
}
	
.header .tabs li {
	display: inline;
	float: right;
	padding: 0px 10px 0px 0px;
	margin: 0px 1px 0px 0px;
	background: transparent url(header-tabs.png) 100% -600px no-repeat;
	border-bottom: 1px solid black;
}

.header .tabs ul a {
	float: left;
	display: block;
	list-style: none;
	padding: 6px 4px 4px 12px;
	background: transparent url(header-tabs.png) 0% -600px no-repeat;
	color: white;
	font-weight: bold;
	text-decoration: none;
}

.header .tabs li:hover { 
	background-position: 100% -400px;
}

.header .tabs li:hover a { 
	background-position: 0% -400px;
}

.header .tabs .active  {
	background-position: 100% -200px;
	border-bottom: 1px solid #b3bac6;
}

.header .tabs .active a {
	background-position: 0% -200px;
	color: #092565;
}
	
.header .tabs .active:hover {
	background-position: 100% 0%;
}

.header .tabs .active:hover a {
	background-position: 0% 0%;
	
}	

.header .end {
	background: transparent url(header-title-right.png) no-repeat;
	width: 11px; height: 127px;
}

/* body table (ugly) */
.body {
	width: 100%;
	border-collapse: collapse;
	border-spacing: 0px;
}

.body .boxes {
	width: 175px;
	vertical-align: top;
}

.body .spacer {
	width: 10px;
}'.! !

!PRStyles methodsFor: 'styles' stamp: 'dc 8/18/2005 14:00'!
basic
	^ self class defaultBasic! !

!PRStyles methodsFor: 'styles' stamp: 'dc 8/18/2005 13:59'!
box
	^ self class defaultBox! !

!PRStyles methodsFor: 'styles' stamp: 'dc 8/18/2005 13:57'!
contents
	^ self class defaultContents! !

!PRStyles methodsFor: 'accessing' stamp: 'lr 4/19/2005 20:39'!
keys
	^ #( basic box layout contents )! !

!PRStyles methodsFor: 'styles' stamp: 'dc 8/18/2005 13:58'!
layout
	^ self class defaultLayout! !

!PRStructureDescription class methodsFor: '*pier-seaside-defaults' stamp: 'lr 11/17/2005 16:09'!
defaultComponentClasses
	^ Array with: PRStructureComponent.! !

MATextInputComponent subclass: #PRStructureComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Magritte'!

!PRStructureComponent methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:09'!
string: aString
	self value: (PRPathLookup
		start: self context structure path: aString
		onError: [ aString ]).! !

MAValidationDecoration subclass: #PRValidationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Seaside-Magritte'!

!PRValidationDecoration methodsFor: 'accessing-configuration' stamp: 'lr 4/17/2005 11:59'!
defaultExceptionSet
	^ Error! !
PRSeasideFrame initialize!
